import unittest
import math

from vector import Vector
from engine import GLScreen

class VectorTests(unittest.TestCase):
    
    angles = range(0,360,20)
    
    def testAnglePreservation(self):
        for angle in self.angles:
            testVec = Vector(1.0, angle, 0, False)
            resultAngle = math.degrees(testVec.angle())
            while resultAngle < 0:
                resultAngle += 360
            while resultAngle >= 360:
                resultAngle -= 360
            self.assertAlmostEqual(resultAngle,angle,3)
            
    def testIndex(self):
        testVec = Vector(1.0, 2.0, 3.0)
        self.assertEqual(testVec[0],testVec.x)
        self.assertEqual(testVec[1],testVec.y)
        self.assertEqual(testVec[2],testVec.z)
        testResults = []
        for position in testVec:
            testResults.append(position)
        self.assertEqual(testResults, [1.0, 2.0, 3.0])
    
class CameraToggleTest(unittest.TestCase):
    
    def testCameraToggle(self):
        screen = GLScreen(640,480)
        
        self.assertEqual(screen.CAMERA_TOPDOWN,screen.cameraMode)
        screen.toggleCameraMode()
        self.assertEqual(screen.CAMERA_CHASE,screen.cameraMode)
        screen.toggleCameraMode()
        self.assertEqual(screen.CAMERA_COOLSCREENSHOT,screen.cameraMode)
        screen.toggleCameraMode()
        self.assertEqual(screen.CAMERA_TOPDOWN,screen.cameraMode)
    
if  __name__ == '__main__':
    unittest.main()
    
